% Solutions to selected exercises of Chapter 1

%% Exercise 1.2

n = 506;
theta = [0.0029   -3.9769];

hessian = 1.0e+006 * [ 1.4404   -0.0007 ; -0.0007    0.0010];

mu = theta(1);
sigma = exp(theta(2));

param = [mu ; sigma];



%Fisher information matrix
IF= hessian/n;

V0 = inv(IF); 

D = diag([ 1 sigma]);

V = D*V0*D;

error = 1.96*sqrt(diag(V)/n);

names = {'mu   ','sigma'};

% (a) 
fprintf('\n Daily estimations\n\n');

for j=1:2
    fprintf(' %5s   %.4f  +/-  %.4f \n',names{j} , param(j) , error(j));
end



% (b)
h = 1/252;

Da = diag([ 1/h, 1/sqrt(h)]);

parama = Da*param;
Va  = Da*V*Da;

errora = 1.96*sqrt(diag(Va)/n);
fprintf('\n\n Annual estimations\n\n');

for j=1:2
    fprintf(' %5s   %.4f  +/-  %.4f \n',names{j} , parama(j) , errora(j));
end




%% Exercise 1.4

[Call, Put] = FormulaBS( 71, 70, 0.02, 3/12, 0.36);
portf0 = 100*Call;

[Call, Put] = FormulaBS( 71, 70, 0.02, 2/12, 0.36);
portf0 = portf0 + 50*Put

%P&L = Portfolio value at t - portfolio value at 0 plus interests

[Call, Put] = FormulaBS( 74.27, 70, 0.02, (3-1)/12, 0.47);
portf1 = 100*Call ;

[Call, Put] = FormulaBS( 74.27, 70, 0.02, (2-1)/12, 0.47);
portf1 = portf1 + 50*Put 

profit = portf1 - portf0 * exp(0.02/12)


%% Exercise 1.6

S =   50:150';
[DeltaCall, DeltaPut, Gamma, Vega] = FormulaBSGreeks(S, 100, 0.015, 1, .25 );

% (a) 
figure
plot(S,DeltaCall)
title('Delta of the call')
figure
plot(S,DeltaPut)
title('Delta of the put')
% (b)

figure
plot(S,Gamma)
title('Gamma')
% (c) 
figure
plot(S,Vega)
title('Vega')

%% Exercise 1.8

% (b)
  ImpliedVolBS(73,75,.015,9/12,1.12)

%% Exercise 1.10

%[Put, Delta, Gamma, Vega ] = BGGreeks(100,100,.015, 1,.25,100000)

 s     = 100;
 K     = 100;
 r     = 0.015;
 tau   = 1;
 sigma = 0.25;
 N     = 1000000;
 
%function [Put, Delta, Gamma, Vega ] = BGGreeks(s,K,r,tau,sigma,N)
 
 Z      = randn(N,1);
 vol    = sqrt(tau) * sigma ;
 Stilde = s*exp( ( r - 0.5 * sigma^2 ) * tau + vol *Z );
 Phi    = max(K-Stilde,0);
 Phia   = exp(-r * tau ) * Phi ;

  
 Put    = mean( Phia );
 Delta  = mean( Z .* Phia / (s * vol ) );
 Vega   = mean(  ( Z.^2 - 1-  vol * Z ) .* Phia/ sigma  );
 Gamma  = Vega / ( s^2 * tau * sigma);
%end
fprintf('\n      Estimated      Real \n\n'); 
estV = [Put Delta Gamma Vega ];
 
[Call Put] = FormulaBS(s,K,r,tau,sigma);
[DeltaCall Delta Gamma Vega ] = FormulaBSGreeks(s,K,r,tau,sigma);
realV = [Put Delta Gamma Vega ];
names = {'Put  ','Delta','Gamma','Vega '};

for j=1:4
    fprintf('%5s  %4.4f       %4.4f\n',names{j},estV(j),realV(j));
end

 