% This folder contains Matlab functions, scripts and data sets that are 
% used in Chapter 1 of
%
%        'Statistical Methods for Financial Engineering'. 
%
% Here is a quick description.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%                 FUNCTIONS AND SCRIPTS
%
% SimBS1D         :  Simulates geometric Brownian motion paths.
%
% EstBS1DExp      : Explicit maximum likelihood estimation and precision of 
%                   the parameters for the Black-Scholes-Merton model.
%
% EstBS1DNum      : Numerical maximum likelihood estimation and precision 
%                   of the parameters for the Black-Scholes-Merton model.
%
% FormulaBS       : Black-Scholes-Merton formula for the value of a call 
%                   and put options.
%
% FormulaGreeksBS : Delta, Gamma and Vega for the value of a call and put
%                   options under the Black-Scholes-Merton model.
%
% AppleCallEst    : Script for computing the errors on the value of call 
%                   options on Apple on January 14th 2011.
%
% ImpliedVolBS    : Implied volatility of a European call option under the 
%                   Black-Scholes-Merton model. 
%
% SolEx           : Solutions of selected exercises.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%                 DATA SETS
%
% ApplePrices     : Data set containing the prices of Apple (aapl) from 
%                   January 13th 2010 to January 14th 2011. 
%
% AppleCalls      : 1 x 4 structure containing the value of Apple, the 
%                   strikes, call prices, libor rates and maturities 
%                   (in days) on call options on Apple, as of January 14th, 
%                   2011. 


