%  Solutions to selected exercises of Chapter 2


%% 2.2

S = [1 -0.68 0.12; -0.68 0.58 -0.09; 0.12 -0.09 0.23];

fprintf('\n\n Cholesky decomposition\n\n')

a  = chol( S )

fprintf('\n\n Checking the answer! a''a = Sigma \n\n')

a'*a


%% 2.4

a = [0.011348  0.005345; 0 0.013248];

S = a'*a;  %covariance matrix

volA = sqrt( S(1,1) );
volB = sqrt( S(2,2) );
R    = S(1,2) / ( volA * volB ); 

fprintf('\n vol A  = %2.4f   vol B = %2.4f  corr = %0.4f \n\n', volA, volB, R);

%% 2.8

addpath('../Chapter01')


%(b)

q2 = 3;
s2 = 43;
q1 = 2;
s1 = 65;

vol1 = .35;
vol2 = .25;
R    = .25;

sigma = sqrt( vol1^2+vol2^2-2*R*vol1*vol2);

tau = 6/12;

D1 = ( log(q2*s2)-log(q1*s1) + 0.5 * sigma^2 * tau ) / ( sigma * sqrt( tau ) );
D2 =  D1 -  sigma * sqrt( tau ) ;

% (c)
[Call Put] = FormulaBS( q2*s2, q1*s1, 0, tau, sigma)

% (d) 
Delta = [ q2*normcdf(D1)  -q1*normcdf(D2) ] 

rmpath('../Chapter01')

%% 2.10
addpath('../Chapter01')

sigma1 = 0.15;
beta1  = 0.40;
R      = 0.65;
r      = 0.02;
rf     = 0.04;
tau    = 3/12;
% (b)

sigma1bar = sqrt( sigma1^2 + beta1^2 + 2 * R * sigma1 * beta1)
Rbar      = (beta1 + R * sigma1 )/sigma1bar

sigma = sqrt( sigma1bar^2 + beta^2 - 2 * Rbar * beta * sigma1bar)  % = sigma1 !!

% (c) 

c0 = exp(-(.04-.02) )* 1.34

% (d)

delta = r - rf + R * sigma1 * beta  % continuous dividend yield

[Call Put ] = FormulaBS( 27, 28, r, tau, sigma, delta)

% Also valid:
%[Call Put ] = FormulaBS( 27*exp(-delta*tau), 28, r, 3/12, sigma)

rmpath('../Chapter01')