% This folder contains Matlab functions, scripts and data sets that are 
% used in Chapter 2 of
%
%        'Statistical Methods for Financial Engineering'. 
%
% Here is a quick description.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%
%                 FUNCTIONS AND SCRIPTS
%
% SimBSMD         : Simulation of correlated geometric Brownian motions.
%
% EstBS2DExp      : Explicit maximum likelihood estimation and precision of 
%                   the parameters for the Black-Scholes-Merton model.
%
% EstBS2DNumCor   : Numerical maximum likelihood estimation and precision 
%                   of the parameters (mu,sigma,rho) for the bivariate 
%                   Black-Scholes-Merton model.
%
% EstBS2DNumVol   : Numerical maximum likelihood estimation and precision 
%                   of the parameters (mu,v) for the Black-Scholes-Merton 
%                   model.
%
% SolEx           : Solutions of selected exercises.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%                 DATA SETS
%
% MicrosoftPrices : Data set containing the prices of Microsoft (msft) from 
%                   January 13th 2010 to January 14th 2011. 


