function [fn] = EstPdfGKpt( x, pts )
% Poinwise estimation of the density with the Gaussian kernel
%
% Input:  x: data (assumed i.i.d.) (n x 1)
%         pts: points at which the density is estimated

n = length(x);
h = std(x) * n^(-0.2);

nbPoint = length( pts );
fn      = zeros( nbPoint, 1 );
for i = 1:nbPoint
    fn(i) = mean( normpdf( ( x - pts(i) ) / h ) ) / h;
end