% Solutions to selected exercises of Chapter 3

%% 3.2

 load('TentMapData.mat');
 
 rej = 0;
 for j = 1:1000
     y = x(:,j);
     
     out = IndLBTest(y,20);
     if out.pvalue < 5
         rej = rej+1;
     end
 end
  fprintf('The power of the Ljung-Box tests is %2.1f%%\n',100*rej/1000);
  
  
 %% 3.4
 
 load('../Chapter02/MicrosoftPrices.mat');
 y = diff(log(MicrosoftPrices));
 
 out = IndGRTest(y,6,1000,.95,1);
 
 fprintf('\n\n P-value  of Fisher test   : %3.1f%%  \n',out.FisherPvalue);
 fprintf('\n\n P-value  of Ljung-Box test: %3.1f%%  \n',out.LJPvalue);
  
 
%% 3.6 

n = 506;
sk = -0.15; 
ku = 3.4;

J1 = n*sk^2/6;
J2 = n*(ku-3)^2/24;

PJ1 = 1-chi2cdf(J1,1);
PJ2 = 1-chi2cdf(J2,1);


JB = J1+J2;
JBPvalue = 100*(1-chi2cdf(JB,2));

JBR = -2*log(PJ1)-2*log(PJ2);

JBRPvalue = 100*(1-chi2cdf(JBR,4));

fprintf('\n\n P-value  of Jarque-Berra  test   : %3.1f%%  \n',JBPvalue);
fprintf(' P-value  of revisited J-B test   : %3.1f%%  \n',JBRPvalue);


%% 3.8
  load('../Chapter02/MicrosoftPrices.mat');
 y = diff(log(MicrosoftPrices));
 
 [cvm, PvalueCVM] = GofGauss1dCVM( y,1000);
 [ks, PvalueKS] = GofGauss1dKS( y,1000);
 
 n = length(y);
sk = skewness(y); 
ku = kurtosis(y);

J1 = n*sk^2/6;
J2 = n*(ku-3)^2/24;

PJ1 = 1-chi2cdf(J1,1);
PJ2 = 1-chi2cdf(J2,1);


JB = J1+J2;
JBPvalue = 100*(1-chi2cdf(JB,2));

JBR = -2*log(PJ1)-2*log(PJ2);

JBRPvalue = 100*(1-chi2cdf(JBR,4));

fprintf('\n\n P-value  of Jarque-Berra  test   : %3.1f%%  \n',JBPvalue);
fprintf(' P-value  of revisited J-B test   : %3.1f%%  \n',JBRPvalue);

 
 
 fprintf(' P-value  of Cramer-von Mises test   : %3.1f%%  \n',PvalueCVM);
 fprintf(' P-value  of Kolmogorov-Smirnov test : %3.1f%%  \n',PvalueKS);
  
%% 3.10

% (b)
n = 250;
N = 10000;

Z = randn(n,1);

[dbstat, pValue, q95] = GofGauss1dCVM( Z, 100000 );

q95

% (c)
stat = zeros(N,1);

for i=1:N
    
   U = rand(n,12) -0.5;
   Z = sum(U,2); % Wilmott approximation
   
   stat(i) = GofGauss1dCVM(Z);
end

power = mean(stat>q95);

fprintf('\n\n Cramer-von Mises test\n\n');

fprintf('\n\n Percentage of rejection of the null hypothesis for sums of uniforms: %3.2f%% \n\n',100*power)
fprintf('\n\n Should be close to 5%% if it is almost Gaussian.\n\n')


for i=1:N
    
   Z = randn(n,1);
   
   stat(i) = GofGauss1dCVM(Z);
end

power = mean(stat>q95);

fprintf('\n\n Cramer-von Mises test\n\n');

fprintf('\n\n Percentage of rejection of the null hypothesis for true Gaussian RV : %3.2f%% \n\n',100*power)
fprintf('\n\n Should be close to 5%%.\n\n')

% (d) 
n = 500;
N = 10000;

Z = randn(n,1);

[dbstat, pValue, q95] = GofGauss1dKS( Z, 100000 );


q95

% (e)
stat = zeros(N,1);

for i=1:N
    
   U = rand(n,12) -0.5;
   Z = sum(U,2); % Wilmott approximation
   
   stat(i) = GofGauss1dKS(Z);
end

power = mean(stat>q95);

fprintf('\n\n Kolmogorov-Smirnov test\n\n');

fprintf('\n\n Percentage of rejection of the null hypothesis for sums of uniforms: %3.2f%% \n\n',100*power)
fprintf('\n\n Should be close to 5%% if it is almost Gaussian.\n\n')


for i=1:N
    
   Z = randn(n,1); 
   
   stat(i) = GofGauss1dKS(Z);
end

power = mean(stat>q95);

fprintf('\n\n Kolmogorov-Smirnov test\n\n');

fprintf('\n\n Percentage of rejection of the null hypothesis for true Gaussian RV : %3.2f%% \n\n',100*power)
fprintf('\n\n Should be close to 5%%.\n\n')


% (f) 

pvalJB = zeros(N,1);
for i=1:N
    
   U = rand(n,12) -0.5;
   Z = sum(U,2); % Wilmott approximation
   sk = skewness(Z) ;
   ku = kurtosis(Z) ;
   JB = n * ( sk^2 / 6 + ( ku - 3 )^2 / 24 ); %Jarque-Berra test statistic
   pvalJB(i)  = 100*(1 - chi2cdf( JB, 2 )); %Jarque-Berra test P-value
end

power = mean(pvalJB < 5);

fprintf('\n\n Jarque-Berra test\n\n');

fprintf('\n\n Percentage of rejection of the null hypothesis for sums of uniforms: %3.2f%% \n\n',100*power)
fprintf('\n\n Should be close to 5%% if it is almost Gaussian.\n\n')


pvalJB = zeros(N,1);
for i=1:N
    
   Z = randn(n,1);
   sk = skewness(Z) ;
   ku = kurtosis(Z) ;
   JB = n * ( sk^2 / 6 + ( ku - 3 )^2 / 24 ); %Jarque-Berra test statistic
   pvalJB(i)  = 100*(1 - chi2cdf( JB, 2 )); %Jarque-Berra test P-value
end

power = mean(pvalJB < 5);

fprintf('\n\n Jarque-Berra test\n\n');

fprintf('\n\n Percentage of rejection of the null hypothesis for true Gaussian RV : %3.2f%% \n\n',100*power)
fprintf('\n\n Should be close to 5%%.\n\n')

% (g) 

pvalJBR = zeros(N,1);
for i=1:N
    
   U  = rand(n,12) -0.5;
   Z  = sum(U,2); % Wilmott approximation
   sk = skewness(Z) ;
   ku = kurtosis(Z) ;
    pval1   = 2 * ( 1 - normcdf( sqrt( n / 6 ) * abs( sk ) ) );
    pval2   = 2 * ( 1 - normcdf( sqrt( n / 24 ) * abs( ku - 3 ) ) );
    JBR     = - 2 * log( pval1 ) - 2 * log( pval2 ); %Improved Jarque-Berra test statistic
    pvalJBR(i) = 100*(1-chi2cdf(JBR,4)); % Improved Jarque-Berra test P-value
   
end

power = mean(pvalJBR < 5);

fprintf('\n\n Revisited Jarque-Berra test\n\n');
fprintf('\n\n Percentage of rejection of the null hypothesis for sums of uniforms: %3.2f%% \n\n',100*power)
fprintf('\n\n Should be close to 5%% if it is almost Gaussian.\n\n')



for i=1:N
    
   
   Z  = randn(n,1);
   sk = skewness(Z) ;
   ku = kurtosis(Z) ;
    pval1   = 2 * ( 1 - normcdf( sqrt( n / 6 ) * abs( sk ) ) );
    pval2   = 2 * ( 1 - normcdf( sqrt( n / 24 ) * abs( ku - 3 ) ) );
    JBR     = - 2 * log( pval1 ) - 2 * log( pval2 ); %Improved Jarque-Berra test statistic
    pvalJBR(i) = 100*(1-chi2cdf(JBR,4)); % Improved Jarque-Berra test P-value
   
end

power = mean(pvalJBR < 5);

fprintf('\n\n Revisited Jarque-Berra test\n\n');

fprintf('\n\n Percentage of rejection of the null hypothesis for true Gaussian RV : %3.2f%% \n\n',100*power)
fprintf('\n\n Should be close to 5%%.\n\n')
