% This folder contains Matlab functions, scripts and data sets that are 
% used in Chapter 3 of
%
%        'Statistical Methods for Financial Engineering'. 
%
% Here is a quick description.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%                 FUNCTIONS AND SCRIPTS
%
% GofGauss1dCVM : Goodness-of-fit test of the Gaussian hypothesis, based on 
%                 the Cramer-von Mises statistic.
%
% GofGauss1dKS  : Goodness-of-fit test of the Gaussian hypothesis, based on 
%                 the Kolmogorov-Smirnov statistic. Analog to lillietest in
%                 the Statistics Toolbox of Matlab.
%
% SerIndTestGR  : Test of serial independence based on Genest & Remillard 
%                 (2004). Also computes the dependogram of p-values.
%
% SerIndTestLB  : Ljung-Box test of serial independence based on
%                 autocorrelations.
%
% EstPdfGK      : Nonparametric estimation of the density using the 
%                 Gaussian kernel. It is evaluated over the range of the
%                 observations. Aloso performs graphical tests and tests of
%                 Gaussianity.
%
% EstPdfGKpt    : Nonparametric estimation of the density evaluated at
%                 given points. The kernel is the Gaussian one.
%
% HedgingLI     : Compute optimal hedging functions for the Black-Scholes 
%                 model using semi-exact calculations.
%
% rotateXlabels : Program downloaded from Matlab Central to rotate labels. 
%
% SolEx         : Solutions of selected exercises.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%                 DATA SETS
%
% TentMap       : 1000 trajectories of 500 successive values of the Tent Map 
%                 process generated by the formula 
%
%                     X(t) = 2 x min{X(t-1), 1-X(t-1)}, t >= 1.
%

