%% 4.2

mud = 400;
sd  = 250;
n   = 506;
p   = 0.99;
mua = 252*mud;
sa  = sqrt(252)*sd;
z   = norminv(p);
f   = normpdf(z)/sa;


VaR   = mua + sa* z;
error = 1.96 * sa * sqrt ( ( 1 + z^2/2)/n );

% np error

error_np = 1.96 * sqrt( p*(1-p)/n) /f;

fprintf('Parametric estimation: VaR = % 4.4f +/-  %4.4f\n',VaR,error);

fprintf('Estimation error in the nonparametric case: %4.4f\n',error_np);


%% 4.4

mud = 400;
sd  = 250;
n   = 506;
p   = 0.99;
mua = 252*mud;
sa  = sqrt(252)*sd;

z = norminv(p);
f = normpdf( z )/(1-p);

VaR = mua + sa* z;

ES  =  mua + sa*f;

error = 1.96 * sa * sqrt ( ( 1 + f^2/2)/n );

% np error

error_np = 1.96 * sa *sqrt( ( (z^2+1 - z*f)/(1-p) - (f-z)^2)/n);

fprintf('Parametric estimation: ES = % 4.4f +/-  %4.4f\n',ES,error);

% explicit solution
fprintf('Estimation error in the nonparametric case: %4.4f\n',error_np);



%estimated solution!
% Z = randn(100000,1);
% w = max(Z-z,0)/(1-p);
% error_np = 1.96 * sa * std(w)/sqrt(n);

%% 4.6

nu = 5;
D = 2.5;

x = 0:0.01:25;
[fhat, f] = SaddleNChi2Pdf(x,nu,D);

figure
plot(x,f);
hold on
plot(x,fhat,'r:')
legend('true density','approx density',0)

[fhat, f] = SaddleNChi2Pdf(x,5, 2.5);

%% 4.8

mu  = .0075;
vol = .02;
r   = 0.02/12;
n   = 60;

S1 = (mu-r)/vol;
E1 = 1.96*sqrt((1+S1^2/2)/n);

D2 = sqrt( normcdf(-S1)*(1+S1^2) - S1*normpdf(S1));

S2 = S1/D2; 

% estimation using Monte Carlo for the variance of the estimators!
X  =randn(100000,1);

Y = min( X/D2 +S2,0);
W = X/D2 - (S2/2)*(Y.^2-1);
E2 = 1.96 * sqrt( var(W)/n);

Omega = ( normpdf(S1)+S1*normcdf(S1))/( normpdf(S1)-S1*normcdf(-S1));

Gbar = Omega/(1+Omega);
G = 1-Gbar;
Y = max(X+S1,0);
Z = max(-S1-X,0);

muY = mean(Y);
vY  = var(Y);
muZ = mean(Z);
vZ  = var(Z);

K =  normpdf(S1)+S1*normcdf(S1) +  normpdf(S1)-S1*normcdf(-S1);

E3 = 1.96* sqrt(  ( 2* Omega^2 + (vY +Omega^2*vZ)/muZ^2 )/n);

E4 = 1.96*sqrt( ( 2*G^2*Gbar^2 + (vZ*Gbar^2+vY*G^2)/K^2 )/n);

fprintf('\n\n 95%% confidence intervals\n\n');
fprintf('Sharpe : %1.4f +/- %3.4f\n',S1,E1);
fprintf('Sortino: %1.4f +/- %3.4f\n',S2,E2);
fprintf('Omega  : %1.4f +/- %3.4f\n',Omega,E3);
fprintf('G bar  : %1.4f +/- %3.4f\n',Gbar,E4);
