% This folder contains Matlab functions, scripts and data sets that are 
% used in Chapter 4 of
%
%        'Statistical Methods for Financial Engineering'. 
%
% Here is a quick description.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%                 FUNCTIONS AND SCRIPTS
%
% SimLosses         : Simulates losses of a simple portfolio.
%
% EstCdf            : Estimation of the empirical distribution function and 
%                     construction of the uniform confidence.
%
% EstVaR            : Estimation of the VaR, together with its estimation 
%                     error.
%
% EstES             : Estimation of the Expected Shortfall, together with  
%                     its estimation error.
%
% EdgeworthCdf      : Approximation of the cdf using Edgeworth expansion.
%
% EdgeworthPdf      : Approximation of the pdf using Edgeworth expansion.
%
% DemoEdgeworth     : Example of approximation of several  distributions.

% CornishFisher     : Approximation of the quantile function using the 
%                     Cornish-Fisher expansion.
%
% DemoCornishFisher : Example of approximation of several quantile 
%                     functions  using the Cornish-Fisher expansion.
%
% DaviesApprox      : Approximation of the cdf using the method of Davies 
%                     for the inversion of the characteristic function.
%
% DemoDavies        : Example of approximation of several distributions 
%                     using Davies approximation.
%
% SaddleNChi2Cdf    : Approximation of the cdf using the saddlepoint 
%                     approximation.
%
% SaddleNChi2Pdf    : Approximation of the pdf using the saddlepoint 
%                     approximation.
%
% DemoSaddlepoint   : Example of approximation of several  distributions 
%                     using the saddlepoint approximation.
%
% EstSharpe         : Estimation and precision of the Sharpe ratio. 
%
% EstSortino        : Estimation and precision of the Sortino ratio. 
%
% EstOmega          : Estimation and precision of the Omega ratio. 
%
% SolEx             : Solutions of selected exercises.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%                 DATA SETS
%
% Losses      : Simulated losses obtained from SimLosses.
%

