%% 5.2

alpha = 0.8;
beta  = 3.25;
sigma = 0.9;

% (a)
fprintf('Gaussian with mean %f and variance %f\n\n',beta, 0.5*sigma^2/alpha);

%(b)

m = 1/360;
lambda = 1/36000;
alphanew = alpha*m;
betanew = lambda*beta;
sigmanew = lambda*sqrt(m)*sigma;

fprintf('Ornstein-Uhlenbeck process with alpha =  %f, beta = %f and   sigma = %f\n\n',alphanew, betanew, sigmanew);


% (c)

q1 = 0.5;
q2 = 0.2;

a = alpha+q2*sigma;
b = (alpha*beta - q1*sigma)/a;

R = b - sigma^2/(200*a^2);
fprintf('Ornstein-Uhlenbeck process with a =  %f, b = %f and   sigma = %f\n\n',a, b, sigma);
fprintf('The limiting yield is %f\n\n',R);


%(d)

a = 0.6;
b = 1.75;

q2 = (a-alpha)/sigma;

q1 = (alpha*beta-a*b)/sigma;

fprintf('The market price of risk is q(t,r) = %f + %f r\n\n',q1,q2);



%% 5.4

alpha = 0.6;
beta  = 2.25;
sigma = 0.5;

% (a)

nu= 4*alpha*beta/sigma^2;

fprintf('\n\n Gamma distribution  with parameters  %f and %f\n\n',nu/2, 0.5*sigma^2/alpha);

%(b)

m = 1/360;
lambda = 1/36000;
alphanew = alpha*m;
betanew = lambda*beta;
sigmanew = sqrt(lambda)*sqrt(m)*sigma;

fprintf('Feller process with alpha =  %f, beta = %f and   sigma = %f\n\n',alphanew, betanew, sigmanew);


% (c)

q1 = 0.25;
q2 = -0.02;

a = alpha+q2*sigma;
b = (alpha*beta - q1*sigma)/a;

gammatilde = sqrt( a^2+ 2*sigma^2/100); 
R =2*a*b/(a+gammatilde);

fprintf('Feller process with a =  %f, b = %f and   sigma = %f\n\n',a, b, sigma);
fprintf('The limiting yield is %f\n\n',R);


%(d)

a = .6;
b = 2.75;

q2 = (a-alpha)/sigma;

q1 = (alpha*beta-a*b)/sigma;

fprintf('The market price of risk is q(t,r) = %f + %f r\n\n',q1,q2);

%% 5.6

alpha =  0.2;
beta  =  2.0;
sigma =  0.9;
q1    = -0.012;
q2    =  0.01;


% (a)
a = alpha+q2*sigma;
b = (alpha*beta - q1*sigma)/a;

fprintf('Ornstein-Uhlenbeck process with a =  %f, b = %f and   sigma = %f\n\n',a, b, sigma);

%(b)

R = b - sigma^2/(200*a^2);

fprintf('The limiting yield is %f\n\n',R);

% (c)

lambda = 1/100;
anew = a;
bnew = lambda*b;
sigmanew = lambda*sigma;

theta      = [alpha,beta,sigma,q1,q2];
thetatilde = [alpha,beta*lambda,sigma*lambda,q1,q2/lambda];
tau       = 3/12;

%[A, B] = getVasicekParam(thetatilde, 3/12, 1 );

[A, B] = getVasicekParam(theta, tau, 100 );

R = 4.5;
r = (tau*R+100*A)/B;

fprintf('The implied short-rate is %f%%\n\n',r);
%(d)

tau = 6/12;
[A, B] = getVasicekParam(theta, tau, 100 );

V0  = 100000*exp(A-B*r/100);
fprintf('The value of the bond is $%6.2f\n\n',V0);

%(e)
phi = exp(-alpha/12);
mu = beta + phi*(r-beta);

vol = sigma*sqrt( 0.5* (1-phi^2)/alpha);

fprintf('Gaussian with mean %f and vol %f\n',mu,vol);

rq  = mu+vol*norminv(.99);

fprintf('r =  %f\n',rq);

%(f)

tau = 5/12;
[A, B] = getVasicekParam(theta, tau, 100 );

v = 100000*exp(A-B*rq/100);

fprintf('The value of v is $%6.2f\n\n',v);


%(g)
ValueAtRisk = V0-exp(-.02/12)*v;

fprintf('The 99%% VaR is $%6.2f\n\n',ValueAtRisk);


%% 5.8

alpha =  0.9;
beta  =  2.5;
sigma =  0.95;
q1    =  0.2;
q2    =  1.1;


% (a)
a = alpha+q2*sigma;
b = (alpha*beta - q1*sigma)/a;

fprintf('Feller process with a =  %f, b = %f and   sigma = %f\n\n',a, b, sigma);

%(b)

gammatilde = sqrt( a^2+ 2*sigma^2/100); 
R =2*a*b/(a+gammatilde);

fprintf('The limiting yield is %f\n\n',R);

% (c)

lambda = 1/100;
anew = a;
bnew = lambda*b;
sigmanew = lambda*sigma;

theta      = [alpha,beta,sigma,q1,q2];
thetatilde = [alpha,beta*lambda,sigma*sqrt(lambda),q1*sqrt(lambda),q2/sqrt(lambda)];
tau       = 1/12;

%[A, B] = getCIRParam(thetatilde, 3/12, 1 );

[A, B] = getCIRParam(theta, tau, 100 );

R = 3.5;
r = (tau*R+100*A)/B;

fprintf('The implied short-rate is %f%%\n\n',r);
%(d)

tau = 6/12;
[A, B] = getCIRParam(theta, tau, 100 );

V0  = 100000*exp(A-B*r/100);
fprintf('The value of the bond is $%6.2f\n\n',V0);

%(e)
phi = exp(-alpha/12);
mu = beta + phi*(r-beta);

vol = sigma*sqrt( 0.5* (1-phi^2)/alpha);

nu    = 4*alpha*beta/sigma^2;
omega = 0.25* sigma^2*(1-exp(-alpha/12))/alpha;
D     = r*exp(-alpha/12)/omega;

fprintf('Non-central chi-square  with nu = %f and non-centrality parameter %f\n',nu,D);

rq  = omega*ncx2inv(.99,nu,D);

fprintf('r =  %f\n',rq);

%(f)

tau = 5/12;
[A, B] = getCIRParam(theta, tau, 100 );

v = 100000*exp(A-B*rq/100);

fprintf('The value of v is $%6.2f\n\n',v);


%(g)
ValueAtRisk = V0-exp(-.02/12)*v;

fprintf('The 99%% VaR is $%6.2f\n\n',ValueAtRisk);

