% This folder contains Matlab functions, scripts and data sets that are 
% used in Chapter 5 of
%
%        'Statistical Methods for Financial Engineering'. 
%
% Here is a quick description.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%                 FUNCTIONS AND SCRIPTS
%
% SimVasicek      : Simulates the Ornstein-Uhlenbeck process.
%
% SimCIR          : Simulates the Feller process.
%
% BondVasicek     : Simulates the values and yields of zero-coupon bonds 
%                   when the spot rate is modeled by a O-U process.
%
% BondCIR         : Simulates the values and yields of zero-coupon bonds
%                   when the spot rate is modeled by a Feller process.
%
% EstVasicek      : Estimates the parameters of the Vasicek model.
%
% EstCIR          : Estimates the parameters of the CIR model.
%
% EstOu           : Estimates the parameters of the O-U process.
%
% EstFeller       : Estimates the parameters of a Feller process.
%
% getVasicekParam : Computes the terms A and B for the price of a zero-coupon
%                   bond under the Vasicek model.
%
% getCIRParam     : Computes the terms A and B for the price of a zero-coupon
%                   bond under the CIR model. 
%
% SolEx           : Solutions of selected exercises.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%                 DATA SETS
%
% DataVasicek     : Yields and maturities simulated from the Vasicek model.
%
% DataCIR         : Yields and maturities simulated from the CIR model. 
