clear all; close all; clc

%% parameters
mu    = 0.08;
sigma = 0.25;
n       = 1000;

%% alpha = 10
alpha = [10; 100; 500; 1000];

for j=1:4
  d = sqrt(mu^2+2*alpha(j)*sigma^2);
  
  b1 = 0.5*(mu +d)/alpha(j);
  b2 = 0.5*(-mu +d)/alpha(j);
  
  y1    = SimLevyGamma( alpha(j), 1, n) ;
 [y2,t] = SimLevyGamma( alpha(j), 1, n) ;
  y     = b1*y1-b2*y2;
 
figure
 plot(t, y);
 title(['Variance Gamma process, \alpha =' num2str(alpha(j)) ',  \mu = ' num2str(mu) ', and \sigma = ' num2str(sigma) ]);
end