function  F = MertonCdf(x,param,h,graph)

%%
if nargin < 4
    graph = 0;
end

%%
mu     = param(1);
sigma  = param(2);
lambda = param(3);
gamma  = param(4);
delta  = param(5);


mu1             = mu * h;
sig1            = sigma * sqrt( h );
jumpIntensity   = lambda * h;
kappa           = exp( gamma + delta^2 / 2 ) - 1;

a =     mu1 - jumpIntensity * kappa - 0.5*sig1^2; 

%%
K = poissinv(1-1E-10,jumpIntensity);


%%
tt = (0:K);

prob = poisspdf(tt,jumpIntensity);


mu2 = a+tt*gamma;
sig2 = sqrt(sig1^2+tt*delta^2);


m = length(x);

xmat = repmat(x,1,(K+1));
mumat = repmat(mu2,m,1);
sigmat = repmat(sig2,m,1);

z = (xmat-mumat) ./ sigmat;

P = normcdf(z);

F = P*prob';
%%
if(graph)
    figure
    plot(x,F);
end
end

