function [tau] = SimPoissonJumps(lambda,T)
% Simulation over [0,T] of the jumping times of a Poisson process
% of intensity lambda
%
% Input
%       lambda: intensity of the Poisson process,
%       T: time.
%
% Output
%       tau: jumping times

M = poissrnd( lambda );

if M > 0
    V   = - log( 1 - rand( M+1, 1 ) );
    S   = cumsum( V );
    tau = T * S( 1:M ) / S( end );
else
    tau =0;
end