%% 6.2

alpha = 20;
beta  = 0.01;
fprintf('First characteristic: %f, second = 0\n', alpha*beta*(1-exp(-1/beta)));

%% 6.4


alpha = 20;
beta  = 0.01;

c = 2/beta^2;
fprintf('First characteristic: %f, second = 0\n', alpha/beta*gamcdf(1,0.5,c));

%% 6.6


r      = 0.02;
mu     = 0.08;
sigma  = 0.22;
lambda = 100;
gamma  = 0.05;
delta  = 0.005;

kappa  = exp(gamma+0.5*delta^2)-1;
a      = mu - 0.5*sigma^2 -lambda*kappa;
zeta0  = 2;
zeta1  = -0.5;

%(a) (b)
sigmanew   = sigma;
gammanew   = gamma+zeta1*delta^2;
deltanew   = delta;
kappanew   = exp(gammanew+0.5*deltanew^2)-1;
lambdanew  = lambda*exp( zeta0 + zeta1*gamma+0.5*zeta1^2*delta^2);
b          = ( r - mu + lambda*kappa- lambdanew*kappanew )/sigma;
anew       = a + b*sigma;
munew      = anew+ .5*sigma^2+lambdanew*kappanew; %just to make sure! We already k now that the new mu is r!!
thetanew = [ munew; sigmanew; lambdanew;gammanew;deltanew];

fprintf('\n\n b = %f\n',b);
names = {'mu    ','sigma ','lambda','gamma ','delta '};


fprintf('New parameters of Merton model\n\n');
for j=1:5
    fprintf('%6s   %4.4f   \n',names{j},thetanew(j));
end


%(c)
S = SimJumpDiffMerton(thetanew, 500, 1/252,1);

%% 6.8


r      = 0.02;
mu     = 0.08;
sigma  = 0.22; %typo in previous file. Changed Nov 27 2013
lambda = 100;
p      = 0.7;
omega  = 0.8;
theta  = 0;
delta  = 0.01;

eta2 = 1/delta;
eta1 = eta2/omega;

kappa = (1+p*eta2-(1-p)*eta1)/(eta1-1)/(eta2+1);


%(a) 
eta1new = 250;
eta2new = 400;
pnew = 0.9;
omeganew= eta2new/eta1new;
deltanew   = 1/eta2new;
lambdanew = 500;
zeta11 = eta1-eta1new;
zeta12 = eta2new - eta2;
zeta01 = log(  (lambdanew/lambda)*(pnew/p)*(eta1new/eta1) );

zeta02 = log(  (lambdanew/lambda)*((1-pnew)/(1-p))*(eta2new/eta2) );

kappanew = (1+pnew*eta2new-(1-pnew)*eta1new)/(eta1new-1)/(eta2new+1);

a      = mu - 0.5*sigma^2 -lambda*kappa;

%(b)
b          = ( r - mu + lambda*kappa- lambdanew*kappanew )/sigma;
anew       = a + b*sigma;
munew      = anew+ .5*sigma^2+lambdanew*kappanew; %just to make sure! We already k now that the new mu is r!!

thetanew = [ munew; sigma; lambdanew; pnew; omeganew; 0; deltanew];

fprintf('\n\n b = %f\n',b);

%(c)

fprintf('\n omega = %f delta = %f \n',omega,delta);
fprintf('\n omegatilde = %f deltatilde = %f \n',omeganew,deltanew);
%thetanew = [ 0.08;0.22;500;0.9;400/250;0;1/400];
%(d)
S = SimJumpDiffKou(thetanew, 500, 1/252 ,1);


