%% 7.2

QTrue = [1.2 1.657 2.8];
addpath('../Chapter04')
%(a)

kappa = zeros(6,1);
for j=1:6
    
  kappa(j) = 0.5 * factorial(j-1)*(2/pi^2)^j * (4^j-1)* zeta (2*j);
end

kappa

%(b)

y = (0:.01:4)';
g = EdgeworthCdf( y, kappa );
figure
plot(y,g)
title('Edgeworth expansion')

%(c)

 p = (.01:.01:.99)';
 
 
QCF = CornishFisher([.9 .95 .99],kappa);

 fprintf('Estimated quantiles (CF): %2.3f   %2.3f   %2.3f\n',QCF);
 fprintf('True quantiles          : %2.3f   %2.3f   %2.3f\n',QTrue);
Q = CornishFisher(p,kappa);

figure
plot(p,Q)
title('Cornish-Fisher expansion of X')

%(d)

N = 100000;
tt = (1:100)';
tt = (2*tt-1).^2;

Z1 = randn(N,100);
Z2 = Z1.^2;
Y = Z2*(1 ./ tt);
X = (4/pi^2) *sort(Y);

%(e)
Fn = (1:N)'/N;

figure
plot(X,Fn)
title('Distribution function (Monte Carlo)')
figure
plot(y,g,'r:')
hold on
plot(X,Fn)
title('Distribution function: Edgeworth vs Monte Carlo')
legend('Edgeworth','Monte Carlo','location','Best');


QMC = quantile(X,[.9 .95 .99]);

 fprintf('Estimated quantiles (MC): %2.3f   %2.3f   %2.3f\n',QMC);
 fprintf('True quantiles          : %2.3f   %2.3f   %2.3f\n',QTrue);
 

figure
plot(p,Q)
hold on
plot(p,quantile(X,p),'r:');
title('Battle of the Quant(ile)s: Cornish-Fisher vs Monte Carlo')
legend('Cornish-Fisher','Monte Carlo','location','Best');

%% 7.4

 c = sqrt(21)*2.251
 
 fprintf('c = %f\n',c);
 
 %% 7.6
 
 mu    = 0.002;
 omega = 2.5e-6; 
 beta  = 0.88;
 alpha = 0.105;
 kappa = 1-alpha-beta;
 
 newmu = 252*mu;
 newomega = omega*252^2;
 newalpha = sqrt(252)*alpha;
 newkappa = 252*kappa;
 
 fprintf('New parameters\n')
 fprintf('mu      = %3.4f\n',newmu);
 fprintf('omega   = %3.4f\n',newomega);
 fprintf('alpha   = %3.4f\n',newalpha);
 fprintf('kappa   = %3.4f\n',newkappa);
 

 
 %% 7.8
 

 
 
  mu   = 0.0005;
 omega = 1.5e-7; 
 beta  = 0.81;
 alpha = 0.17;
 kappa = 1-alpha-beta;
 nu    = 5.2;
 
 newmu = 252*mu;
 newomega = omega*252^2;
 newalpha = sqrt(252)*alpha;
 newkappa = 252*kappa;
 gamma1 = 2/sqrt(nu);
 gamma2 = 3+6/nu;
 
 volZ2 = newalpha*sqrt(gamma2-1);
 cor12 = gamma1/sqrt(gamma2-1);
 fprintf('New parameters\n')
 fprintf('mu         = %3.4f\n',newmu);
 fprintf('omega      = %3.4f\n',newomega);
 fprintf('alpha      = %3.4f\n',newalpha);
 fprintf('kappa      = %3.4f\n',newkappa);
 fprintf('volZ2      = %3.4f\n',volZ2);
 fprintf('cor(Z1,Z2) = %3.4f\n',cor12);
 
 
 