% This folder contains Matlab functions, scripts and data sets that are 
% used in Chapter 7 of
%
%        'Statistical Methods for Financial Engineering'. 
%
% Here is a quick description.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%                 FUNCTIONS AND SCRIPTS
%
% SimGARCHGaussian : Simulates a GARCH(p,q) process with Gaussian 
%                    innovations.
% SimGARCHGED      : Simulates a GARCH(p,q) process with GED innovations.
%
% DemoGARCH        : Generates two GARCH processes with the same
%                    innovations, and starting from different points.
%
% EstGARCHGaussian : Maximum likelihood estimation and precision of the
%                    parameters of a GARCH(p,q) process with Gaussian 
%                    innovations.
%
% EstGARCHGED      : Maximum likelihood estimation and precision of the
%                    parameters of a GARCH(p,q) process with GED 
%                    innovations.
%
% EstGARCHGED      : Maximum likelihood estimation and precision of the
%                    parameters of a GARCH(p,q) process with Student 
%                    innovations.
%
% GofGARCHGaussian : Test of normality for the innovations of an ARMA-GARCH 
%                    process.
%
% GofGARCHGED      : Goodness-of-fit test for the hypothesis that the 
%                    innovations of a GARCH process are GED.
%
% SolEx            : Solutions of selected exercises.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%                 DATA SETS
%
% DataGarch     : Simulated data from a GARCH(1,1) model with parameters 
%                 mu = -0.004, omega = 0.005, alpha = 0.6, beta= 0.3, and
%                 Gaussian innovations. 
%

