
clear all; close all; clc

t   = (1:1:48)' ; % maturities
tt  = ( 49 - t ) / 12;

Spread  = zeros( 48, 7 );
V       = zeros( 48, 7 );
Pdef    = zeros( 48, 7 );

for m=1:48
    
    [Val, S, Pt, PD] =  BondMarkovChain( tt(m), 0.02 );
    
    Spread(m,:) = S;
    V(m,:) = Val;
    Pdef(m,:) = PD(1:7);
    
end

figure
plot(t,Spread);
%xlabel('Time to maturity');
title('Spread (%) in terms of the time to maturity');
legend({'AAA','AA','A','BBB','BB','B','CCC'}, 'location', 'best');

figure
%xlabel('Time to maturity');
plot(t,V);
title('Value of the Bonds for different ratings in terms of the time to maturity (Face value = 1000$)');
legend({'AAA','AA','A','BBB','BB','B','CCC'}, 'location', 'best');

Pdef = zeros(100,7);

tt = (1:100)';
for m=1:100
    
    [Val, S, Pt, PD] =  BondMarkovChain(m,0.02);
    
    Pdef(m,:) = PD(1:7);
    
end

figure
plot(tt,Pdef);
plot(tt,Pdef(:,4),'-');
hold on
plot(tt,Pdef(:,5),'r:');
hold on
plot(tt,Pdef(:,6),'g-.')
hold on
plot(tt,Pdef(:,7),'k--')
legend({'BBB','BB','B','CCC'}, 'location', 'best');


