function [ Kn, t] = EstKendall( X, t )
% Computes the empirical Kendall function at selected points.
%
% Input
%        X : data ( n x d matrix),
%        t : points of evaluation of K (m x 1 vector).
%           If missing argument, Kn is evaluated at the sorted
%           pseudo-observations.
%
% Output
%        t : points of evaluation of K,
%        Kn: Kn(t).

[U, V] = Pseudos( X );

if nargin <2
    t = sort( V );
end

m   = length( t );
Kn  = zeros( m, 1 );

for j = 1:m
    Kn(j) = mean( ( V <= t( j ) ) );
end