function U = SimPlackett(theta,n)
% Generates observations from the Plackett copula.

U1 = rand(n,1);
V  = rand(n,1);

a = theta;
W = V.*(1-V);
A = a+(a-1)^2*W;


C = W .* (1+(a-1)*U1).^2;
B = 2*(a-1)*W .* (1-(a+1)*U1)-a;

U2 = 0.5*(-B + sign(V-0.5) .* sqrt(B.^2-4*A.*C))./A;
U = [U1 U2];

