%% 8.2


%(a)
addpath('../Chapter04')
% cumulants

kappa = zeros(1:6);

k=2; %card (A)=k
for j=1:6
      kappa(j) = 0.5*factorial(j-1) * (zeta(2*j))^k * (2*6^k/pi^k/pi^k)^j;
end

%(b)

y = (0:.01:4)';
g = EdgeworthCdf( y, kappa );
figure
plot(y,g)
title('Edgeworth expansion of X')



%(c)

 p = (.01:.01:.99)';
 
 
QCF = CornishFisher([.9 .95 .99],kappa);

 fprintf('Estimated quantiles (CF): %2.3f   %2.3f   %2.3f\n',QCF);
 

Q = CornishFisher(p,kappa);

figure
plot(p,Q);

%(d)

tic
N = 1000000;

n = 100;

T  =zeros(N,1);

tt =  1 ./(1:n)';
tt2 = tt.^2;
b = tt2*tt2' * 36/pi^4;

for i=1:N
  
Z  =randn(n,n);
D = (Z.^2) .* b ;
T(i) = sum(sum(D,2));
end

Q = quantile(T,.95);
fprintf('95%% quantile of T_2: %2.2f\n',Q);


T = sort(T);

F = (1:N)'/N;

figure
plot(T,F);
title('Estimated cdf of T_2')


toc


%(e)

fprintf('Estimated quantiles (MC): %2.3f   %2.3f   %2.3f\n',quantile(T,[.9 .95 .99]));
figure
plot(y,g,'r:')
hold on
plot(T,F)
title('Distribution function: Edgeworth vs Monte Carlo')
legend('Edgeworth','Monte Carlo','location','Best');


figure
plot(p,Q);
hold on
plot(p,quantile(T,p),'r:');
title('Battle of the Quant(ile)s: Cornish-Fisher vs Monte Carlo')
legend('Cornish-Fisher','Monte Carlo','location','Best');


%% 8.4

tau = 0.5;


filename= 'Ex8.4.html';
fp = fopen(filename,'w');
fprintf(fp,'<b>Exercise 8.4 </b> <br/><br/>');
%(a)
rho = sin(0.5*pi*tau);
fprintf(fp,' Gaussian: <font> &rho;   </font> = %1.4f  <br/> \n', rho);
%(b)
fprintf(fp,' Student : <font> &rho;   </font> = %1.4f  <br/> \n', rho);
%(c)
theta = 2*tau/(1-tau);
fprintf(fp,' Clayton : <font> &theta; </font> = %1.4f  <br/> \n', theta);
%(d)

theta = fsolve(@(x) tauFrank(x)-tau,.5); 

fprintf(fp,' Frank   : <font> &theta; </font> = %1.4f  <br/> \n', theta);
%(e)
theta=1-tau;
fprintf(fp,' Gumbel  : <font> &theta; </font> = %1.4f  <br/> \n', theta);



fclose(fp);

web(filename)


%% 8.6

tau = .3;

error_tau = .08;

theta = 2*tau/(1-tau);

error_theta = 2*error_tau/(1-tau)^2;

filename= 'Ex8.6.html';
fp = fopen(filename,'w');

fprintf(fp,'<b>Exercise 8.6 </b> <br/><br/>');
fprintf(fp,'<font> &theta;  =  2&tau;/(1-&tau;), so the Jacobian is 2/(1-&tau;)&sup2;. </font><br/><br/>');
fprintf(fp,' Answer: <font> &theta; </font> = %1.4f  <font> &plusmn;  </font> %1.4f \n', theta, error_theta);
fclose(fp);

web(filename)


    %% 8.7
filename= 'ExChap8.7.html';
fp = fopen(filename,'w');
fprintf(fp,'<b>Exercise 8.7 </b> <br/><br/>');
% (a)
theta = -1/3;
tau = theta/(2+theta);
fprintf(fp,' (a) <font> Clayton with &theta; </font> = %1.4f  <font> and &tau; </font> = %1.4f <br/><br/>\n', theta, tau);

theta = 1/2;
tau  = 1-theta;

fprintf(fp,' (b) <font> Gumbel with &theta; </font> =  %1.4f  <font>  and &tau; </font> =  %1.4f <br/><br/>\n', theta, tau);

theta = 3/4;

a = theta;
tau = 1  -2*(a + (1-a)^2*log(1-a))/(3*a^2);

fprintf(fp,' (b) <font>A-M-H with &theta; </font> =  %1.4f  <font>  and &tau; </font> =  %1.4f <br/><br/>\n', theta, tau);


fclose(fp);

web(filename)


%% 8.8

%Frank copula

tau0 = -.3;
error_tau = 0.04;



% theta as a function of rho
 theta = fsolve(@(x) tauFrank(x)-tau0,0.5)

 [tau dilog] = tauFrank(theta)
 
x= log(theta);
 

tauprime = -(4/x^2)*(1 +2*dilog/x)/theta+ (4/(1-theta))/x ;


% Stluzky 
error_theta  = error_tau/abs(tauprime);

filename= 'Ex8.8.html';
fp = fopen(filename,'w');

fprintf(fp,'<b>Exercise 8.8 </b> <br/><br/>');
fprintf(fp,' Answer: <font> &theta; </font> = %1.4f  <font> &plusmn;  </font> %1.4f \n', theta, error_theta);
fclose(fp);

web(filename)

%% 8.10

%Plackett copula
filename= 'Ex8.10.html';
fp = fopen(filename,'w');


rho0 = .6;
error_rho = 0.03;


% rho as a function of theta
rho = @(x) (1+x)/(x-1)-2*x*log(x)/(x-1)^2;


% theta as a function of rho
 theta = fsolve(@(x) rho(x)-rho0,1.5);

% Jacobian of rho -> theta
rhoprime = @(x) -4/(x-1)^2 + 2*(x+1)*log(x)/(x-1)^3;

% Stluzky 
error_theta  = error_rho/rhoprime(theta);

fprintf(fp,'<b>Exercise 8.10 </b> <br/><br/>');
fprintf(fp,' Answer: <font> &theta; </font> = %1.4f  <font> &plusmn;  </font> %1.4f \n', theta, error_theta);
fclose(fp);

web(filename)



%% 8.12


     stat= [0.3851 0.5533 0.5498 0.5537];
       std= [0.5439 0.7148 0.6723 0.6934];
     error= [0.0477 0.0627 0.0589 0.0608];
   
     names= {'Kendall tau'  'Spearman rho'  'van der Waerden rho'  'Pearson rho'};
     
 tau = stat(1);
 error_tau = error(1);
 
 filename= 'Ex8.12.html';
fp = fopen(filename,'w');
fprintf(fp,'<b>Exercise 8.12 </b> <br/><br/>');

%(a)
rho = sin(0.5*pi*tau);
fprintf(fp,' Gaussian: <font> &rho;   </font> = %1.4f <font> &plusmn;  </font> %1.4f<br/> \n', stat(3),error(3));

%(b)
fprintf(fp,' Student : <font> &rho;   </font> = %1.4f <font> &plusmn;  </font> %1.4f<br/> \n', sin(0.5*pi*tau), 0.5*pi*cos(0.5*pi*tau)*error_tau);


%(c)
theta = 2*tau/(1-tau);

error_theta = 2*error_tau/(1-tau)^2;
fprintf(fp,' Clayton : <font> &theta; </font> = %1.4f   <font> &plusmn;  </font> %1.4f<br/> \n',theta,error_theta);
%(d)

theta = fsolve(@(x) tauFrank(x)-tau,.5); 

[tauest dilog] = tauFrank(theta)
 
 x= log(theta);
 
% Jacobian of rho -> theta
tauprime =  -4/x^2/theta + 4/x/(1-theta) -8*dilog/x^3/theta;




% Stluzky 
error_theta  = error_tau/abs(tauprime);


fprintf(fp,' Frank   : <font> &theta; </font> = %1.4f <font> &plusmn;  </font> %1.8f<br/> \n',theta,error_theta);

%(e)

fprintf(fp,' Gumbel  : <font> &theta; </font> = %1.4f  <font> &plusmn;  </font> %1.4f<br/> \n',1-tau,error_tau);

fclose(fp);

web(filename)


%% 8.14

%(a)

t = (0:1:3)';
p = 1-exp(-1/15);
P = binopdf(t,3,1/15)

fprintf('Independence copula\n')
for j=1:4
    fprintf('P(D = %d) = %0.4f\n',j-1, P(j) );
end


fprintf('\n\n\n')
%(b)

t = (0:1:3)';
p = 1-exp(-1/15);
P = zeros(4,1);
P(4) = p;
P(1) = 1-p;

fprintf('Frechet-Hoeffding upper bound copula\n')

for j=1:4
    fprintf('P(D = %d) = %0.4f\n',j-1, P(j) );
end

fprintf('\n\n\n')

%(c)
tau = 0.7;

theta = 2*tau/(1-tau);

alpha = 1/theta;

n=100000;
d=3;
  UU = -log(rand(n,d));
  S = repmat(gamrnd(alpha,1,n,1),1,d); 
  T = alpha*log(1 + UU ./ S);
  
 D = sum( (T<=1),2) ;

P(1) = mean( (D==0) );
P(2) = mean( (D==1) );
P(3) = mean( (D==2) );
P(4) = mean( (D==3) );

fprintf('Clayton copula with tau = 0.7\n')
for j=1:4
    fprintf('P(D = %d) = %0.4f\n',j-1, P(j) );
end

%% 8.16

fprintf('See function SimPlackett\n');