% This folder contains Matlab functions, scripts and data sets that are 
% used in Chapter 8 of
%
%        'Statistical Methods for Financial Engineering'. 
%
% Here is a quick description.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%                 FUNCTIONS AND SCRIPTS
%
% BondMarkovChain      : Compute the values of defaultable bonds using 
%                        credit ratings from S&P and the continuous time 
%                        Markov chain model.
%
% DemoBondMarkovChain  : Example of computations of the values of defaultable 
%                        bonds for the continuous time Markov chain model.
%
% DemoBondPortfolio    : Generates a portfolio of bonds using the
%                        CreditMetrics methodology.
%
% DemoCopula           : 3d graphs of some copula families.
%
% ExAppleMicrosoft     : Computations done Section 8.11.
%
% EstDep               : Estimation and precision of some dependence 
%                        measures: Kendall tau, Spearman rho, van der Waerden 
%                        coefficient and the traditional Pearson correlation.
%
% EstKendall           : Computes the empirical Kendall function at selected 
%                        points.
%
% Graph3dCopula        : Compute the graph of an empirical bivariate copula 
%                        and a contour plot of the estiamted density.
%
%
% Pseudos              : Compute pseudo-observations (normalized ranks U 
%                        and probability integral transform V) for a sample 
%                        of random vectors.
%
% SimPlackett          : Generates observations from a Plackett copula.
%
% SimArchi             : Generates observations from a Clauton, Frank or 
%                        Gumbel copula.
%
% IndGRTest            : Test of independence for a copula based on the
%                        empirical copula.
%
% IndKendallTest       : Tests of independence for a copula based on the
%                        empirical Kendal function.
%
% GofRosenCopula       : Compute the Cramer-von Mises statistics SnB and
%                        SnC and their P-values for a test of goodness-of-fit 
%                        based on the Rosenblatt transform. The copula 
%                        families are: Gaussian, Student, Clayton, Frank and 
%                        Gumbel.
%
% TestChangePoint      : Test of stationarity for univariate data.
%
% TestChangePointCopula: Test of stationarity for the copula of multivariate 
%                        data.
%
% SolEx                : Solutions of selected exercises.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%                 DATA SETS
%
% DataTentMapCop     : Data set generated from the Tent Map. 
%

