function [y z] = SimKalman(alpha,phi,Q,R,n);
%  Generated observations and signal  from the model
%
%   Z_i = alpha + phi Z_{i-1} +w_i, w_i \sim N(0,Q),
%   Y_i = Z_i +\epsilon_i, \epsilon_i \sim N(0,R),
%
%
% Exemple: [y z ] = SimKalman(.08,.8,.001,.1,500);

Z0 = randn(1,1);

w = sqrt(Q)*randn(n,1);

z = zeros(n,1);

z(1) = alpha + phi*Z0+w(1);
for i=2:n
    z(i) = alpha + phi*z(i-1) + w(i);
end


y = z + sqrt(R)*randn(n,1);