%% 9.2

%(a)
tau = (1:12)'/12;

F = FuturesSchwartz(16,0.025,tau,.05, 1.876, .106, .393, .527, .766, .198);

for j=1:12
    fprintf('%d-month maturity, futures value = %2.2f\n',j,F(j));
end

%(b)

 delta = (-.5:.1:.5)';
 
 F1 = FuturesSchwartz(16,delta,1/12,.05, 1.876, .106, .393, .527, .766, .198);
 
 F6 = FuturesSchwartz(16,delta,6/12,.05, 1.876, .106, .393, .527, .766, .198);
 

 
 figure
 
 plot(delta,F1,'b')
 hold on
 plot(delta,F6,'r-.');
 legend('1-month','6-month','location','Best');

 
%% 9.4

 %(a)
 h=1/252;
 d = 3; %number of years
 n = 252*d; %number of days
 [s delta]  = SimSchwartz(16,0.025, n-1, 1/252, .142, 1.876, .106, .393, .527, .766, 1) ;
 
 %(b) 
 tt = (0:1:20)';
 t = [42-tt , 63-tt, 126-tt, 189-tt, 231-tt];
 
 tau = repmat(t,12*d,1);
 
 s2  = repmat(s,1,5);
 d2  = repmat(delta,1,5);
 
 r = .05; kappa = 1.876; alpha = .106; sigma1 = .393; sigma2 = .527; rho = .766; lambda = .198;
 
 
 [F A B] = FuturesSchwartz(s2,d2,tau,r, kappa, alpha, sigma1, sigma2, rho, lambda);
 
 %(c)
 
 eps = randn(n,5)*diag([0.001*ones(5,1)])*sqrt(h);
 
 y = log(F)+ eps;
 plot(y)
 legend('2-month','3-month','6-month','9-month','12-month','location','Best')
 
 %
 
 out = EstSchwartz(y,tau,r);
 
 %% 9.6
 
  
filename= 'Ex9.6.html';
fp = fopen(filename,'w');

fprintf(fp,'<b>Exercise 9.6 </b> <br/><br/>');
fprintf(fp,'<font>The new signal Z<sub>i</sub> has to components: X<sub>i</sub> and w<sub>i</sub>.</font><br/>\n\n')
fprintf(fp,'<font> &mu; has components &alpha; and 0, F is a matrix with element F<sub>11</sub> = &phi;, F<sub>ij</sub>=0 otherwise. </font> <br/>');
fprintf(fp,'<font>Also,  G is a vector with components G<sub>j</sub>=1 for j=1,2, and the noise w<sub>i</sub> stays the same.</font><br/>')
fprintf(fp,'<font>Finally, H = (1,&beta;) with &beta; = &rho;(R/Q)<sup>1/2</sup>, and the new noise &epsilon;<sub>i</sub> has variance (1-&rho;<sup>2</sup>)R, and is independent of w<sub>i</sub>.</font>')

fclose(fp);
web(filename)