% This folder contains Matlab functions, scripts and data sets that are 
% used in Chapter 9 of
%
%        'Statistical Methods for Financial Engineering'. 
%
% Here is a quick description.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%                 FUNCTIONS AND SCRIPTS
%
% SimKalman   : Generates a AR(1) type signal with noisy observations.
%                  
% SimSV       : Generates the stochastic volatility model of Ruiz (1994).
%
% EstKalman   : Estimation of the parameters and prediction of a linear 
%               Gaussian model, using Kalman filter.
%
% EstKalmanBS : Estimation of the parameters and prediction for the 
%               Black-Scholes-Merton model, using Kalman filter. 
%
% EstKalmanSV : Estimation of the parameters and prediction of a stochastic 
%               volatility model using Kalman filter.
%
% EstSPF    :  Estimation of the parameters of a linear Gaussian model
%              using a smooth particle filter.
%
% EstSPFSV    : Estimation of the parameters of a stochastic volatility
%               model using a smooth particle filter.
%
% SolEx       : Solutions of selected exercises.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%                 DATA SETS
%
% DataKalman     : Simulated data from a Kalman model.
%
% DataSV         : Simulated data from a stochastic volatility  model.
