%
% Plot S&P500 with mm/yy
%
%%
load('DataSP500')

dd = sp500.dates(2:end);
y = diff(log(sp500.prices));
plot(dd,y);
set(gca,'XTick',dd);
datetick('x',12);
title(['Daily log-returns from ', datestr(dd(1)), ' to ', datestr(dd(end))]);

d1 = sp500.dates;
plot(d1,sp500.prices);
set(gca,'XTick',dd);
datetick('x',12)
title(['Daily values from ', datestr(d1(1)), ' to ', datestr(d1(end))]);


%%
% addpath('d:/Perso/MyMatlab/GOF')
% 
% out = GofHMM(y,3,10000, .0001,10000);

tic
out = GofHMM1d(y,3,10000, .0001,1000);
toc

 eta0 = out.eta(end,:)

Q=out.Q;

nu0 =eta0*Q^1000;

mu = 252 * out.mu';

sigma = sqrt( 252 ) * out.sigma';


eta1 = eta0*Q;
eta5 = eta0*Q^5;

x = (-.06:.0005:.06)';

m = length(x);
fr = zeros(m,3);


for j=1:3
    z = ( x-out.mu(j) ) / out.sigma(j);
    fr(:,j) = normpdf( z ) / out.sigma(j);
end

f1 = fr * eta1';

figure
plot(x,f1)


f5 = fr * eta5';

finf = fr * nu0';
figure
plot(x,f5)

figure
plot(x,f1)
hold on
plot(x,f5,'r--')
hold on 
plot(x,finf,'k-.')
legend('1-day','5-day','\infty','location','Best')


%%
load('../Chapter01/ApplePrices')
y  = diff(log(ApplePrices));


tic
out = GofHMM1d(y,3,10000, .0001,1000);
toc

 eta0 = out.eta(end,:)

Q=out.Q;

nu0 =eta0*Q^1000;

mu = 252 * out.mu';

sigma = sqrt( 252 ) * out.sigma';


eta1 = eta0*Q;
eta5 = eta0*Q^5;

x = (-.06:.0005:.06)';

m = length(x);
fr = zeros(m,3);


for j=1:3
    z = ( x-out.mu(j) ) / out.sigma(j);
    fr(:,j) = normpdf( z ) / out.sigma(j);
end

f1 = fr * eta1';

figure
plot(x,f1)


f5 = fr * eta5';

finf = fr * nu0';
figure
plot(x,f5)

figure
plot(x,f1)
hold on
plot(x,f5,'r--')
hold on 
plot(x,finf,'k-.')
legend('1-day','5-day','\infty','location','Best')




