%% 10.2

%(a)
phi   = 0.4;

theta = -0.5;

psi   =  phi-theta;

F = [ 0 1 ; 0 phi]


g = [ 1; psi]


a = [1;0]


%(b)

U00 = g*g'+ (F *g)*(F*g)'/(1-phi^2)

%(c) 
f2 = a' * U00 * a 


%(d)

B = a * a' ;
for i = 1:20
    i
    U0 = F * U00 * F' + g * g';
    f2  =  a' * U0 * a 
    U00 = U0 - U0 * B * U0/f2
end

%% 10.4

%(a)
phi1 = 0.4;
phi2 = -0.1;

theta = -0.3;
theta2 = 0.1;

psi1 =  phi1-theta1;

psi2 = phi2-theta2 + psi1 * phi1;


F = [ 0 1 0; 0 0 1; 0 phi2 phi1]

g = [ 1; psi1; psi2]
a = [1 ; 0 ; 0]


%(b)
U00 = g * g' ;


for k = 1:50
    y = F^k * g;
   U00 = U00 + y * y' ;
end

U00


%(c) 
f2 = a' * U00 * a 


%(d)

B = a * a' ;
for i = 1:20
    i
    U0 = F * U00 * F' + g * g';
    f2  =  a' * U0 * a 
    U00 = U0 - U0 * B * U0/f2
end


%% 10.6

%(a)

Q = [   0.96436    0.03558       0.00006 ;...
         0.00009    0.13856       0.86135 ;...
         0.02905    0.79537       0.17558 ];

   eta0 = [ 0.0193    0.5417    0.4391];
   
eta1 = eta0*Q;

fprintf('\n Regimes prediction for January 18th\n\n');
for j=1:3
    fprintf('    Regime %d   Probability %0.4f\n',j,eta1(j));
end

%(b)
p1   = eta1(1);
p2   = p1+eta0(2);



n = 1E5;
U  = rand(n,1);
n1  = sum((U<p1));
n2  = sum((U>p1) .* (U<p2) );
n3  = sum( (U>p2));

mu    =  [0.0020    0.0053    0.0009]; %daily values
sigma = [ 0.0264    0.0167    0.0086];

Z1  = mu(1)+sigma(1) * randn(n1,1);
Z2  = mu(2)+sigma(2) * randn(n2,1);
Z3  = mu(3)+sigma(3) * randn(n3,1);

Z  = [Z1;Z2;Z3];

bounds = quantile(Z,[.025,.975]);
S(2) = 348.48*exp(bounds(2));
S(1) = 348.48*exp(bounds(1));
fprintf('\n\n Quantiles for returns\n\n')
fprintf(' 2.5%% quantile = %0.4f\n',bounds(1));
fprintf('97.5%% quantile = %0.4f\n',bounds(2));

%(c)
fprintf('\n\nlower bound = %1.4f\n',S(1));
fprintf('real  value = 340.65\n');
fprintf('upper bound = %1.4f  \n',S(2));
fprintf('\n\n The real value belongs to the prediction interval!\n\n');
%(d)

y = log(340.65/348.48);

z =  normpdf ( ( y - mu ) ./ sigma ) ./ sigma ;

etanew0 = eta1 .* z;  %unnormalized !
etanew  = etanew0/sum(etanew0); 

fprintf('\n Updated regimes prediction for January 18th\n\n');
for j=1:3
    fprintf('    Regime %d   Probability %0.4f\n',j,etanew(j));
end

%% 10.8

filename= 'Ex10.8.html';
fp = fopen(filename,'w');

fprintf(fp,'<b>Exercise 10.8 </b> <br/><br/>');
fprintf(fp,'\n\n <font>(a) One must test the hypothesis that a sampling proportion is less that 3%%, if the real one in 5%%.</font><br/>\n\n')
z = sqrt(100)*(.03-.05)/sqrt(.05*.95) 
fprintf(fp,'<font> Under H<sub>0</sub> , Z =  (p&#770; -p) &frasl;</font> <span style="white-space: nowrap; font-size:larger">&radic;<span style="text-decoration:overline;">&nbsp;p(1-p)/N&nbsp;</span></span><font> is approximately N(0,1). Here p= 0.05.</font><br/>');
fprintf(fp,'<font>We need to compute  P( p&#770; < .03 | p&#770; < .05 ), since already know that the sample proportion is less than 5%%.</font><br/>');
fprintf(fp,'<font> The P-value  of the test is :  </font> %.4f%%\n<br/>',100*2*normcdf(z));
z = sqrt(1000)*(.03-.05)/sqrt(.05*.95);
fprintf(fp,'<br/><br/><font> (b)  The solution is to increase the sample size. For example, with N=1000, the P-value of the test on the proportion would have been </font>%0.4f%%<br/>\n',200*normcdf(z));
fprintf(fp,'<font> Thus, for example, we would have concluded that the true proportion is significantly smaller than 5%%. </font>');
fclose(fp);

web(filename)

