function f = PDFNChi2( x, nu, lambda  )
%This function computes the probability density function of a
%non-central chi-square distribution with degree of freedom  nu >0 
%and non-centrality parameter lambda > 0

if lambda~=0
    
   % f = 0.5 * exp( - 0.5 * (lambda+x) ) .* ( x ./ lambda ) .^ ( 0.25 * nu - 0.5 ) .* besseli( 0.5 * nu - 1, sqrt( lambda .* x ) );
    z = sqrt( lambda .* x );
    f = 0.5 * exp( - 0.5 * (lambda+x) ) .* ( x ./ lambda ) .^ ( 0.25 * nu ) .*(nu* besseli( 0.5 * nu , z )+ z .* besseli( 0.5 * nu + 1, z ));

else
    
    f = chi2pdf(x,nu);
    
end


