function [x] = SimNChi2( nu, lambda )
% This function generates variates from a non-central chi-square distribution 
% with degree of freedom nu >0 and non-centrality parameter lambda >0 

if nu > 1

    x = chi2rnd( nu-1 ) + ( randn() + sqrt( lambda ) )^2;
    
else
    
    x = chi2rnd( nu + 2 * poissrnd( 0.5 * lambda ) );

end
