% This folder contains Matlab functions, scripts and data sets that are 
% used in Appendix B of
%
%        'Statistical Methods for Financial Engineering'. 
%
% Here is a quick description.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%                 FUNCTIONS AND SCRIPTS
%
% EstCauchy    : NumericalMaximum likelihood estimation and precision of 
%                   the parameters for the Cauchy distribution.
%
% NumJacobian  : Numerical estimation of the Jacobian.
%
% NumHessian   : Numerical estimation of the Hessian.
%
% DescStats    : Computation of the main descriptive statistics.
%
% SolEx        : Solutions of selected exercises.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%                 DATA SETS
%
% DataCauchy     : Simulation of observations from a Cauchy distribution
%                  with mu = 10 and sigma = 5.
%

